<template>
  <div>
    <b-button  variant="success mt-4" v-b-modal.modal1>
        + New Field
    </b-button>

    <b-modal id="modal1" centered title="Create new Field"
              @ok='addNewField(schemaName, fieldName, defaultType)'
              :headerClass='modal1.headerClass'>
      <b-tabs small card ref="tabs" v-model="modal1.tabIndex">
        <b-tab title="Field">
          <form @submit.stop.prevent="submit">
            <b-form-input v-model="fieldName" type="text" size='sm' placeholder='Field name'/>
            <b-form-select v-model='defaultType' size='sm' :options="options"
                            class='ml-4'/>
          </form>
        </b-tab>
        <b-tab title="Options">
          I'm the second tab
        </b-tab>
      </b-tabs>

    </b-modal>


  </div>
</template>
<script>
import gql from 'graphql-tag';

import { schemaTypes } from '@/data/parse';


export default {
  name: "schema-new-field",

  props: ['schemaName'],

  data() {
    return {
      defaultType: 'String',
      fieldName: '',
      modal1: {
        headerClass: 'd-none',
        tabIndex: 0,
      }
    };
  },

  methods: {
    addNewField(schema, name, type) {
      this.$apollo.mutate({
        mutation: gql`mutation create($schema: String, $name: String, $type: String) {
          addNewField(schemaName: $schema, fieldName: $name, fieldType: $type)
        }`,
        variables: { schema, name, type },
        update: (store, { data: { addNewField }}) => {
          this.$parent.$apollo.queries.schemaTypes.refetch();
        },
      })
    }
  },

  computed: {
    options() {
      return schemaTypes.map((val) => {
        return { value: val.type, text: val.type }
      })
    },
  }
}
</script>
<style lang="scss" scoped>
</style>
